import java.io.*;
import java.util.Vector;
public class ClusteringOfShortTags_searchReverse_hash_open {
	final static int distanceLimit = 1; 
	
	//Hamming distance and mismatch position
	static int[] DistancePosition(MyTag_reverse a, MyTag_reverse b){
		int dis = 0;
		int[] pos = new int[distanceLimit];
		for(int i=0;i<a.tagSeq.length();i++){
			if(a.tagSeq.charAt(i)!=b.tagSeq.charAt(i)){
				dis++;
				if(dis <= distanceLimit)
					pos[dis-1] = i;
				else
					break;
			}	
		}
		pos[0] = dis;
		return pos;
	}
		
	static double combination_error(int n, int i,double Perror){
		double tResult = 1* Math.pow(Perror,i) * Math.pow(1-Perror,n-i);
		if(i==0) return tResult;
		
		int i2 = n-i;
		if(i2 < i){
		    i = i2;
		}
		for(int j=0;j<i;j++){
			tResult = tResult*(n-j);
			tResult = tResult/(j+1);
		}
		return tResult;
	}
	
	static double normal(double z, double[][] normal_dis){
		double p = 0.0;
		z = Math.abs(z);
		if(z>4)
			p = 0.0;
		else 
			p =  normal_dis [new Double(z/0.1).intValue()][new Double((z % 0.1)/0.01).intValue()];
		return p;
	}
	static double Relativity(MyTag_reverse a, MyTag_reverse b,int position, double[][] normal_dis){
		int n = a.frequence;
		int r = b.frequence;
		double Perror = 0.0;

		if(b.tagSeq.charAt(position)=='A')
			Perror = Double.parseDouble((a.qv.split(" "))[position].split(",")[0])/n;	
		else if (b.tagSeq.charAt(position)=='C')
			Perror = Double.parseDouble((a.qv.split(" "))[position].split(",")[1])/n;	
		else if (b.tagSeq.charAt(position)=='G')
			Perror = Double.parseDouble((a.qv.split(" "))[position].split(",")[2])/n;	
		else if (b.tagSeq.charAt(position)=='T')
			Perror = Double.parseDouble((a.qv.split(" "))[position].split(",")[3])/n;	

		double z = 0.0;
		double p = 0.0;
		

		if(r<=n*Perror){
			p = 1.0;
		}
		else if(n*Perror*(1-Perror) < 10){
			int r_round = new Double(r+0.5).intValue();
			if (r_round >= n/2){
				for (int i=r_round;i<=n ;i++){
					p += combination_error(n,i,Perror);					
					//System.out.println(i+"\t"+n +"\t"+p+ "\t"+combination_error(n,i,Perror));
				}
			}
			else{
				p = 1.0;
				for (int i=0;i<r_round ;i++){
					p -= combination_error(n,i,Perror);
					//System.out.println(i+"\t"+p+ "\t"+combination_error(n,i,Perror));
				}
			}
		}	
		else if(r>n*Perror){ 
			z = ((r-0.5)-n*Perror) /Math.sqrt(n*Perror*(1-Perror));
			if(z<0)
				p = 1.0;
			else
				p = normal(z, normal_dis);
		}
		
		/*System.out.println(a.tagSeq+"\t"+b.tagSeq);
		System.out.println(a.frequence+"\t"+b.frequence);
		System.out.println(position);
		System.out.println((a.qv.split(" "))[position]);
		System.out.println(p);*/
		return p;
	}
	
	static String[] GenerateOneMismatchSeq(String a, int p){
		String[] seqs = new String[3];
		String firstPart = "";
		String lastPart = "";
		if(p>0)
			firstPart = a.substring(0,p);
		if(p<a.length()-1)
			lastPart = a.substring(p+1,a.length());
		
		if(a.charAt(p) =='A'){
			seqs[0] =  firstPart + "C" +lastPart;
			seqs[1] =  firstPart + "G" +lastPart;
			seqs[2] =  firstPart + "T" +lastPart;
		}
		else if(a.charAt(p) =='C'){
			seqs[0] =  firstPart + "A" +lastPart;
			seqs[1] =  firstPart + "G" +lastPart;
			seqs[2] =  firstPart + "T" +lastPart;
		}
		else if(a.charAt(p) =='G'){
			seqs[0] =  firstPart + "A" +lastPart;
			seqs[1] =  firstPart + "C" +lastPart;
			seqs[2] =  firstPart + "T" +lastPart;
		}
		else if(a.charAt(p) =='T'){
			seqs[0] =  firstPart + "A" +lastPart;
			seqs[1] =  firstPart + "C" +lastPart;
			seqs[2] =  firstPart + "G" +lastPart;
		}
		else{
			seqs[0] = "Errors occured in method GenerateOneMismatchSeq.";
			System.out.println("Errors occured in method GenerateOneMismatchSeq.");
		}
		return seqs;
	}
	
	static String PickLongestMemberChain(String members){
		String[] m = members.split(" ");
		String longestMemberChain = "";
		int num = 0;
		for (int i=0; i<m.length; i++){
			if (num < m[i].split(">").length){
				num = m[i].split(">").length;
				longestMemberChain = m[i];
			}
		}
		return longestMemberChain;
	}
	
	public static void main(String[] args) {

		String filename1 = ""; //"tag sequence	\t error expectation: a,c,g,t \t frequency"
		String filename2 = "clusterOutput.txt";
		String filename3 = "normal_distribution";
		
		double pValue = 0.01;
		int BucketSize = 1000003;
		
		
		String filename4 = "parent-childRelation.txt";
		
		
        for (int i=0; i<args.length; ++i) {
            if ("-i".equals(args[i])) {
            	filename1 = args[++i];
            } else if ("-o".equals(args[i])) {
            	filename2 = args[++i];
            } else if ("-stat".equals(args[i])) {
            	filename3 = args[++i];
            } else if ("-hashSize".equals(args[i])) {
            	BucketSize = Integer.parseInt(args[++i]);
            } else if ("-p".equals(args[i])) {
            	pValue = Double.parseDouble(args[++i]);
            } else {
	        System.err.println("Error: Unknown option was used.");
            }
        }
		
		if(pValue<0.0000001){
			System.out.println("Acording to file \"normal_distribution\", we can only use threshold of P-value >= 0.0000001.");
			System.exit(0);
		}
			

		Hash H = new Hash(BucketSize);
		
		try {			
			BufferedReader reader1  = new BufferedReader(new FileReader(new File(filename1)));
			BufferedReader reader2  = new BufferedReader(new FileReader(new File(filename3)));
			PrintWriter writer1 = new PrintWriter(new BufferedWriter(new FileWriter(filename2)));			
			String line;
			
			double[][] normal_dis = new double[55][10];
			line = reader2.readLine();
			int raw = 0;
			while ((line = reader2.readLine()) != null) {
				String[] m = line.split("\t");
				for(int i=0;i<10;i++){
					normal_dis [raw][i] = Double.parseDouble(m[i+1]);
				}
				raw++;
			}
			reader2.close();
			
			Vector tags = new Vector();
			int n = 0;
			while ((line = reader1.readLine()) != null) {
				tags.add(new MyTagCluster_reverse (line));
				((MyTagCluster_reverse)tags.get(n)).members = n +" ";
				H.LinearProblingInsert(((MyTagCluster_reverse)tags.get(n)).repTag.tagSeq, n);
				n++;		
			}
	
			int[] tags_final = new int[tags.size()];
			for(int i = 0;i<tags_final.length;i++){
				tags_final[i] = 1;
			}					
			
			for(int i=tags_final.length-1; i>-1; i--){			
				String[] oneMismatchSeqs = new String[((MyTagCluster_reverse)tags.get(i)).repTag.tagSeq.length()*3]; 
				for(int k=0;k<oneMismatchSeqs.length/3;k++){
					oneMismatchSeqs[3*k] = GenerateOneMismatchSeq(((MyTagCluster_reverse)tags.get(i)).repTag.tagSeq,k)[0];
					oneMismatchSeqs[3*k+1] = GenerateOneMismatchSeq(((MyTagCluster_reverse)tags.get(i)).repTag.tagSeq,k)[1];
					oneMismatchSeqs[3*k+2] = GenerateOneMismatchSeq(((MyTagCluster_reverse)tags.get(i)).repTag.tagSeq,k)[2];
				}
							
				double Fmax = -1.0;
				int Fmax_tag = 0;
				double p = 0.0;
				int flag = 0;
				Record answer = new Record();
				int posOfMismatch = -1; 
				int F = 0;
				for(int j=0;j<oneMismatchSeqs.length;j++){
					answer = H.LinearProblingSearch(oneMismatchSeqs[j]);
					if ( answer!=null && ((MyTagCluster_reverse)tags.get(i)).repTag.frequence < ((MyTagCluster_reverse)tags.get(answer.num)).repTag.frequence ){
						flag = 1;				
						F = ((MyTagCluster_reverse)tags.get(answer.num)).repTag.frequence;
						if (F > Fmax){
							Fmax = F;
							Fmax_tag =  answer.num ;
							posOfMismatch = j/3;
						}
					}
				}

				if (flag ==1)
					p = Relativity (((MyTagCluster_reverse)tags.get(Fmax_tag)).repTag,((MyTagCluster_reverse)tags.get(i)).repTag, posOfMismatch , normal_dis);					

				if (flag ==1 && p>=pValue ){				
					((MyTagCluster_reverse)tags.get(Fmax_tag)).frequence_all += ((MyTagCluster_reverse)tags.get(i)).frequence_all;					
					((MyTagCluster_reverse)tags.get(Fmax_tag)).cluster_num += ((MyTagCluster_reverse)tags.get(i)).cluster_num;
					
					if(((MyTagCluster_reverse)tags.get(i)).members.indexOf(">") >-1){
							((MyTagCluster_reverse)tags.get(Fmax_tag)).members +=  
								PickLongestMemberChain (((MyTagCluster_reverse)tags.get(i)).members
								.substring(0, ((MyTagCluster_reverse)tags.get(i)).members.length()-1))
								 +"->"+Fmax_tag +" ";
					}
					else{
							((MyTagCluster_reverse)tags.get(Fmax_tag)).members +=  
								((MyTagCluster_reverse)tags.get(i)).members
								.substring(0, ((MyTagCluster_reverse)tags.get(i)).members.length()-1) +"->"+Fmax_tag +" ";
					}					
					//((MyTagCluster_reverse)tags.get(Fmax_tag)).mismatch_tags.add((MyTagCluster_reverse)tags.get(i));
					((MyTagCluster_reverse)tags.get(Fmax_tag)).all_members += " "+ ((MyTagCluster_reverse)tags.get(i)).all_members;
					((MyTagCluster_reverse)tags.get(Fmax_tag)).mismatch_tags_num += ((MyTagCluster_reverse)tags.get(i)).cluster_num;					
					((MyTagCluster_reverse)tags.get(Fmax_tag)).member_num_final += ((MyTagCluster_reverse)tags.get(i)).member_num_final;
					tags_final[i] = 0;
				}
			}
			
			PrintWriter writer2 = new PrintWriter(new BufferedWriter(new FileWriter(filename4)));
			
			writer1.println("Representative sequence" +"\t"+"Frequency of rep" +"\t"+"Frequency of cluster" +"\t"+"Members in cluster" +"\t"+"Longest path");
			writer2.println("Read sequence" +"\t"+"Representative sequence");
			
			for(int i = 0;i<tags_final.length;i++){
				if (tags_final[i] == 1){
					writer1.println(((MyTagCluster_reverse)tags.get(i)).Print_open());
					
                    String[] m = ((MyTagCluster_reverse)tags.get(i)).all_members.split(" ");
                    for(int j=0; j<m.length ;j++){
                            writer2.println(m[j] +"\t"+ ((MyTagCluster_reverse)tags.get(i)).repTag.tagSeq);
                    }

				}				
			}
			
			reader1.close();
			writer1.close();
			writer2.close();

		} catch (IOException e) {
			System.out.println(e);
		}
	}
}
